'use strict';

const fs = require('fs').promises;
const inflect = require('inflect');
const tensify = require('tensify');

const dictionary = require('./dictionary.json');

function getTenses(word) {
	try {
		const { past, past_participle: participle } = tensify(word);

		return { past, participle };
	} catch (error) {
		return {};
	}
}

async function init() {
	const formsDictionary = Object.fromEntries(Object.entries(dictionary).flatMap(([word, definition]) => {
		const plural = inflect.pluralize(word);
		const { past, participle } = getTenses(word);

		return [
			[word, definition],
			...(plural && !dictionary[plural] ? [[plural, `Plural of ${word}`]] : []),
			...(past && !dictionary[past] ? [[past, `Past tense of ${word}`]] : []),
			...(participle && !dictionary[participle] ? [[past, `Past participle of ${word}`]] : []),
		];
	}));

	const validWords = Object.entries(formsDictionary).filter(([word]) => /^[a-zA-Z]+$/.test(word));

	const sortedWords = validWords.reduce((acc, [rawWord, fullDefinition]) => {
		const word = rawWord.toLowerCase();
		const anagram = word.split('').sort().join('');
		const definitions = fullDefinition.split(/\d+\.\s+/).filter(Boolean).map((definition) => definition.split('.')[0].toLowerCase());

		if (!acc[anagram.length]) {
			acc[anagram.length] = {};
		}

		if (!acc[anagram.length][anagram]) {
			acc[anagram.length][anagram] = [];
		}

		acc[anagram.length][anagram].push({ word, definitions });

		return acc;
	}, {});

	await fs.writeFile('./mash-words.json', JSON.stringify(sortedWords, null, 4));
}

init();
